/* ***************
// Desc: JS File for QuickNote, this is where all the loading and saving of the file is.
// 
// Author: Jed Brown (jedbro@gmx.net)
// Additional code from Cdn's Chrome Edit extension.
// Version: 0.4
// Last modified: September 27th, 2003
****************** */
try {
	const pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var tabtosendto = pref.getIntPref('quicknote.totabint',null);
	var qnlangPref = pref.getBoolPref('quicknote.langsupport');
	var userdefinedtab1file = nsPreferences.getLocalizedUnicharPref('quicknote.tab1path');
	var userdefinedtab2file = nsPreferences.getLocalizedUnicharPref('quicknote.tab2path');
	var userdefinedtab3file = nsPreferences.getLocalizedUnicharPref('quicknote.tab3path');
	var userdefinedtab4file = nsPreferences.getLocalizedUnicharPref('quicknote.tab4path');
	var qnfirststart = pref.getBoolPref('quicknote.firststart');
	var qnshowurl = pref.getBoolPref('quicknote.showUrl');
	var numberoftabs = pref.getIntPref('quicknote.numtabs',null);

}catch (e) {
	// foobar!
}
 
function closeWindow()
{
  window.close();
}

function getTextareaText(tNodeID) {
 var tat = document.getElementById(tNodeID).value;
 if (qnlangPref){
	 return escape(tat);
 }else{
	 return tat;
 }
}

function setTextareaText(thetext,tNodeID) {
 document.getElementById(tNodeID).value= unescape(thetext);
}

////////////////////////////////////////////////////////////////////////////////
// loadIt
//
// Desc: Loads the files
// Parameters: fileName: The name of the file to save two. targetNodeID: Where it is headed to (onePad, twoPad)
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function loadIt(fileName,targetNodeID) {
	var d = new DirUtils;
	var p = d.getUserChromeDir();
	var fName = fileName;
	
	var f = new File(p);
	var target = f.nsIFile;
	var target2 = target;
	target.append(fName);
	
	f=new File(target.path);
	
	//If file already exists then just open it.
	if (f.exists()) {
		f.open()
		var stuff=f.read()
		f.close()
		setTextareaText(stuff,targetNodeID);
	}
	
	// If it doesn't exist, create the file, then make sure it exists, then open.
	else if (!f.exists() ) { 	
		f.create();
		
		if (f.exists()) {
			f.open()
			var stuff=f.read()
			f.close()
			setTextareaText(stuff,targetNodeID);
		}
		else {setTextareaText('// #2 Currently you do not have a user.js file.',targetNodeID)}
		
	}
	else {setTextareaText('// #1 Currently you do not have a user.js file.',targetNodeID)}
	
}

////////////////////////////////////////////////////////////////////////////////
// loadAFile
//
// Desc: Loads the files
// Parameters: fileName: The name of the file to save two. targetNodeID: Where it is headed to (onePad, twoPad)
// Returns: true or false
////////////////////////////////////////////////////////////////////////////////
function loadAFile(userTabpath, targetNodeID) {
	//var d = new DirUtils;
	//var myUserDirPlease = d.getUserChromeDir();
	var targetNodeID2 = targetNodeID;
	
	//var fName = txtFilePicker("Open a Text File",0,myUserDirPlease);
//	alert(userTabpath);
	if(userTabpath==null || userTabpath=='Blank'){
	    setTextareaText('//No file found!\n 1)You may need to re-open QuickNote\n 2)Set your user File in the Prefernces\n 3)or the archive you chose is invalid. ',targetNodeID);
	    return false;
	}
	var f = new File(userTabpath);
	var target = f.nsIFile;
	//var target2 = target;
	//target.append(userTabpath); 
	f=new File(target.path);
	
	//If file already exists then just open it.
	if (f.exists()) {
		f.open();
		var stuff=f.read();
		f.close();
		setTextareaText(stuff,targetNodeID);
	}
	
	// If it doesn't exist, create the file, then make sure it exists, then open.
	else if (!f.exists() ) { 	
		setTextareaText('// 2# File is invalid or does not exist..',targetNodeID);
		}
		
}
////////////////////////////////////////////////////////////////////////////////
// saveIt
//
// Desc: Saves the file using JSlib DirUtils and File
// Parameters: fileName: The name of the file to save two. targetNodeID: Where it is headed to (onePad, twoPad). button: Which save button this affects!
// Returns: nothing
// To-Do: Merge saveIt and saveAFile. Stupid to have both!
////////////////////////////////////////////////////////////////////////////////
function saveIt(targetNodeID,button) {
	var data = getTextareaText(targetNodeID);
	//var d = new DirUtils;
	//var p = d.getUserChromeDir();
	var fName;
	if(targetNodeID == "onePad"){
		fName = userdefinedtab1file;
	}
	if(targetNodeID == "twoPad"){
		fName = userdefinedtab2file;
	}
	if(targetNodeID == "threePad"){
		fName = userdefinedtab3file;
	}
	if(targetNodeID == "fourPad"){
		fName = userdefinedtab4file;
	}
	
	
	var f = new File(fName);
	var target = f.nsIFile;
	//target.append(fName);  
	f=new File(target.path);
	
	f.open('w')
	p = f.write(data)
	f.close()
	
	if(p)
		document.getElementById(button).setAttribute("disabled", "true");
}

////////////////////////////////////////////////////////////////////////////////
// saveIfChanged
//
// Desc: Auto-save function!
// Parameters: none
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function saveIfChanged() {

    if ( ! document.getElementById('save-one').hasAttribute('disabled') )
      saveIt('onePad', 'save-as1');

    if ( ! document.getElementById('save-two').hasAttribute('disabled') )
      saveIt('twoPad', 'save-as2');
    
    if ( ! document.getElementById('save-three').hasAttribute('disabled') )
      saveIt('threePad', 'save-as3');
    
    if ( ! document.getElementById('save-four').hasAttribute('disabled') )
      saveIt('fourPad', 'save-as4');

}


////////////////////////////////////////////////////////////////////////////////
// OnLoad
//
// Desc: Make sure this loads with QuickNote to get the onePad data
// Parameters: onePad to copy the selection (via arguments[0])
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
var onePad;  // textbox holding the text to copy from onePad
var twoPad;  // textbox holding the text to copy from twoPad
var oneTab;  // Tab number one
var twoTab;  // Tab number two

function OnLoad() {
	if(!qnfirststart || qnfirststart == false){
		alert("Welcome to QuickNote:\n This is your first time using QN, so please set your file paths!");
		window.open('qnsettings.xul','QuickNote - Settings','chrome,centerscreen,resizable'); 
		window.close();
	}
	
	if(numberoftabs == '0' || numberoftabs == '1')
	{
		document.getElementById("oneTab").collapsed = true;
		document.getElementById("twoTab").collapsed = true;
		document.getElementById("threeTab").collapsed = true;
		document.getElementById("fourTab").collapsed = true;
		loadAFile(userdefinedtab1file, 'onePad');
	}
	if(numberoftabs == '2')
	{
		document.getElementById("twoTab").collapsed = false;
		loadAFile(userdefinedtab1file, 'onePad');
		loadAFile(userdefinedtab2file,'twoPad');
	}
	if(numberoftabs == '3')
	{
		document.getElementById("twoTab").collapsed = false;
		document.getElementById("threeTab").collapsed = false;
		loadAFile(userdefinedtab1file, 'onePad');
		loadAFile(userdefinedtab2file,'twoPad');
		loadAFile(userdefinedtab3file,'threePad');
	}
	if(numberoftabs == '4')
	{
		document.getElementById("twoTab").collapsed = false;
		document.getElementById("threeTab").collapsed = false;
		document.getElementById("fourTab").collapsed = false;
		loadAFile(userdefinedtab1file, 'onePad');
		loadAFile(userdefinedtab2file,'twoPad');
		loadAFile(userdefinedtab3file,'threePad');
		loadAFile(userdefinedtab4file,'fourPad');
	}if(!numberoftabs)
	{
		document.getElementById("threeTab").collapsed = true;
		document.getElementById("fourTab").collapsed = true;
		
		loadAFile(userdefinedtab1file, 'onePad');
		loadAFile(userdefinedtab2file,'twoPad');
	}

 
// ## Decides where to send the text to.. ##
 if (tabtosendto && tabtosendto >='2'){
	  
	  if(tabtosendto == '2')
	  {
		  twoPad = document.getElementById("twoPad");
		  twoPad.value = twoPad.value+"\n";
		  twoPad.value = twoPad.value+window.arguments[0];
		  saveIt('twoPad', 'save-two');
		  sizeToContent();
		  twoPad.focus();
	  }
	  if(tabtosendto == '3')
	  {
		  threePad = document.getElementById("threePad");
		  threePad.value = threePad.value+"\n";
		  threePad.value = threePad.value+window.arguments[0];
		  saveIt('threePad', 'save-three');
		  sizeToContent();
		  threePad.focus();
	  }
	  if(tabtosendto == '4')
	  {
		  fourPad = document.getElementById("fourPad");
		  fourPad.value = fourPad.value+"\n";
		  fourPad.value = fourPad.value+window.arguments[0];
		  saveIt('fourPad', 'save-four');
		  sizeToContent();
		  fourPad.focus();
	  }


  }else{
	  onePad = document.getElementById("onePad");
	  onePad.value = onePad.value+"\n";
	  onePad.value = onePad.value+window.arguments[0];
	  saveIt('onePad', 'save-one');
	  sizeToContent();
	  onePad.focus();
  }
}

//**** SaveAS and FilePicker ******

////////////////////////////////////////////////////////////////////////////////
// txtFilePicker
//
// Parameters:
//  aTitle: title to go on file picker window
//  aSave: 1 if picking file to save/overwrite, 0 if picking file to load
//  aStart: directory to start from
//    This must be an nsILocalFile.  new Dir("foo") in jslib/io/dir.js will
//    do the trick, but you have to do it yourself.
// Returns:
//  Name of file picked, in URL format, or null if cancelled
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function txtFilePicker(aTitle, aSave) {
  var retVal = null;
  try {
   
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, aTitle, (aSave ? nsIFilePicker.modeSave : nsIFilePicker.modeOpen));
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
    
    /*
    if(aStart) {
      fp.displayDirectory = aStart;
    }
    */
    var result=fp.show();
    if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
      //retVal=fp.fileURL.spec;
      retVal=fp.file.path;
      //alert("Should return retval: "+retVal+" YES!"); // DEBUG
    }
  }
  catch (ex) {
  }
  return retVal;
}

////////////////////////////////////////////////////////////////////////////////
// saveListAs
//
// Parameters: targetNodeID: What to save
// button: Which button was pressed
// Returns: true if list saved, false otherwise
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function saveListAs(targetNodeID, button) {
  var d = new DirUtils;
  var myUserDirPlease = d.getUserChromeDir();
  var targetNodeID2 = targetNodeID;
  var fName = txtFilePicker("Save the File as",1,myUserDirPlease);
  if(fName==null){
    return false;
  }
  
  var isSaved = saveAFile(fName, targetNodeID2, button);
  //if(isSaved){
	//document.getElementById(button).setAttribute("disabled", "true");
  //}
  return isSaved;
}

////////////////////////////////////////////////////////////////////////////////
// saveAFile
//
// Parameters:
//  aUrl: string name of file to open, in platform-specific or file:// format
//  targetNodeID: where the data is to save!
//  button: The button that makes the call (for disable/enable)
// Returns: true if list saved, false otherwise
// To-Do: Merge saveIt and saveAFile. Stupid to have both!
////////////////////////////////////////////////////////////////////////////////
function saveAFile(aUrl, targetNodeID, button) {

  var aFile=aUrl;
  if(aUrl.substring(0,4)=="file") {
    var fUtils = new FileUtils();
    aFile = fUtils.urlToPath(aUrl);
  }

  var f = new File(aFile);
  if(!f.open("w")) {
    alert("File could not be opened!");
    return false;
  }
  //f.write(tzList.join("\n")+"\n");
  var data = getTextareaText(targetNodeID);
  f.write(data);
  f.close();

  //document.getElementById(button).setAttribute("disabled", "true");
  return true;
}


////////////////////////////////////////////////////////////////////////////////
// mailIt
//
// Parameters:
//  targetNodeID: where the data is to save!
// Returns: true
// To-Do: TESTING, can't get to get Thunderbird to load a Compose window 
////////////////////////////////////////////////////////////////////////////////
function qnMailWindow(targetNodeID) {
	var QNmailText = getTextareaText(targetNodeID).value;
	window.openDialog("chrome://quicknote/content/mail.xul",
		  "_blank", "chrome,all,dialog", QNmailText);
	return true;
}

